package com.example.echo.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Element;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.CheckBox;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DisclosurePanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HTMLPanel;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.InlineLabel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.MenuBar;
import com.google.gwt.user.client.ui.MenuItem;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.RadioButton;
import com.google.gwt.user.client.ui.TabPanel;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Tree;
import com.google.gwt.user.client.ui.TreeItem;
import com.google.gwt.user.client.ui.Widget;

public class AllWidgets extends Composite {

    interface AllWidgetsUiBinder extends UiBinder<Widget, AllWidgets> {
    }

    private static AllWidgetsUiBinder uiBinder = GWT.create(AllWidgetsUiBinder.class);

    @UiField TextBox textBox;
    @UiField PasswordTextBox passwordBox;
    @UiField TextArea textArea;
    @UiField CheckBox checkBox;
    @UiField RadioButton radioButton1;
    @UiField RadioButton radioButton2;
    @UiField ListBox listBox;
    @UiField Button submitButton;
    @UiField Label outputLabel;
    @UiField Hyperlink hyperlink;
    @UiField InlineLabel inlineLabel;
    @UiField HTML htmlContent;
    @UiField Image image;
    @UiField DisclosurePanel disclosurePanel;
    @UiField Tree tree;
    @UiField MenuBar menuBar;
    @UiField TabPanel tabPanel;
    @UiField HTMLPanel datePickerContainer;

    public AllWidgets() {
        initWidget(uiBinder.createAndBindUi(this));

        // Initialize ListBox
        listBox.addItem("Option 1");
        listBox.addItem("Option 2");
        listBox.addItem("Option 3");

        // Initialize Image
        image.setUrl("images/slide1.jpg");

        // Initialize HTML
        htmlContent.setHTML("<p>This is <b>HTML</b> content styled with Bootstrap.</p>");

        // Initialize InlineLabel
        inlineLabel.setText("Active");

        // Initialize Tree
        TreeItem root = new TreeItem(SafeHtmlUtils.fromString("Root"));
        root.addItem(new TreeItem(SafeHtmlUtils.fromString("Child 1")));
        root.addItem(new TreeItem(SafeHtmlUtils.fromString("Child 2")));
        tree.addItem(root);

        // Initialize MenuBar
        MenuBar subMenu = new MenuBar(true);
        subMenu.addItem(new MenuItem("Submenu Item", (Command) () -> Window.alert("Submenu clicked")));
        menuBar.addItem("Menu", subMenu);

        // Initialize TabPanel
        tabPanel.add(new Label("Content for Tab 1"), "Tab 1");
        tabPanel.add(new Label("Content for Tab 2"), "Tab 2");
        tabPanel.selectTab(0);

        // Button click handler
        submitButton.addClickHandler((ClickEvent event) -> {
            String text = textBox.getText();
            outputLabel.setText("Submitted: " + text);
            outputLabel.removeStyleName("d-none");
        });

        // Initialize jQuery DatePicker
        initDatePicker(datePickerContainer.getElement());
    }

    private native void initDatePicker(Element element) /*-{
        var self = this;
        $wnd.jQuery(element).datepicker({
            dateFormat: "yy-mm-dd",
            onSelect: function(dateText) {
                self.@com.example.echo.client.AllWidgets::onDateSelected(Ljava/lang/String;)(dateText);
            }
        });
    }-*/;

    public void onDateSelected(String date) {
        outputLabel.setText("Selected Date: " + date);
        outputLabel.removeStyleName("d-none");
    }
}
