package com.example.echo.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.uibinder.client.UiHandler;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.event.dom.client.ClickEvent;

public class EchoWidget extends Composite {
    // UiBinder interface
    interface EchoWidgetUiBinder extends UiBinder<Widget, EchoWidget> {
    }

    private static EchoWidgetUiBinder uiBinder = GWT.create(EchoWidgetUiBinder.class);
    private final EchoServiceAsync echoService = GWT.create(EchoService.class);

    // UI fields bound to XML
    @UiField
    TextBox textBox;

    @UiField
    Button sendButton;

    @UiField
    Label responseLabel;

    public EchoWidget() {
        // Initialize the widget
        initWidget(uiBinder.createAndBindUi(this));
        // set placeholder programatically
        textBox.getElement().setAttribute("placeholder", "Enter your message");
    }

    @UiHandler("sendButton")
    void onSendButtonClick(ClickEvent event) {
        String text = textBox.getText();
        if (text == null || text.trim().isEmpty()) {
            Window.alert("Please enter some text");
            return;
        }

        // Call the echo service
        echoService.echo(text, new AsyncCallback<String>() {
            @Override
            public void onFailure(Throwable caught) {
                Window.alert("Error: " + caught.getMessage());
            }

            @Override
            public void onSuccess(String result) {
                responseLabel.setText(result);
                responseLabel.getElement().setAttribute("class", "alert alert-info");
            }
        });
    }
}
