package com.example.echo.server;

import jakarta.servlet.Filter;
import jakarta.servlet.FilterChain;
import jakarta.servlet.FilterConfig;
import jakarta.servlet.RequestDispatcher;
import jakarta.servlet.ServletException;
import jakarta.servlet.ServletRequest;
import jakarta.servlet.ServletResponse;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.io.IOException;

public class PushStateFilter implements Filter {

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
        // No initialization needed
    }

    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
            throws IOException, ServletException {
        HttpServletRequest httpRequest = (HttpServletRequest) request;
        HttpServletResponse httpResponse = (HttpServletResponse) response;

        // Skip filtering for static resources and GWT-generated files
        String uri = httpRequest.getRequestURI();
        if (uri.matches(".*\\.(html|css|js|jpg|jpeg|png|gif|ico|xml|txt)(\\?.*)?$") || uri.contains("/echo/")) {
            chain.doFilter(request, response);
            return;
        }
        /*
        if (uri.matches(".*\\.(html|css|js|jpg|jpeg|png|gif|ico|xml|txt)$") || uri.contains("/echo/")) {
            chain.doFilter(request, response); // Serve the file directly
            return;
        }
         */
 /*
        if (uri.endsWith(".html") || uri.contains("/echo/") || uri.endsWith(".css") || uri.endsWith(".js")
                || uri.endsWith(".jpg") || uri.endsWith(".ico") || uri.endsWith(".gif") || uri.endsWith(".xml") || uri.endsWith(".txt")) {
            chain.doFilter(request, response); // Serve the file directly
            return;
        }
         */
        // Redirect all other requests to Echo.html
        RequestDispatcher dispatcher = request.getRequestDispatcher("/Echo.html");
        dispatcher.forward(request, response);
    }

    @Override
    public void destroy() {
        // No cleanup needed
    }
}
